local ITEMS = {
    [2840] = {amount = 90000, faction = "Neutral"},
    [8831] = {amount = 26000, faction = "Neutral"},
    [4304] = {amount = 80000, faction = "Neutral"},
    [6887] = {amount = 17000, faction = "Neutral"},
    [14529] = {amount = 400000, faction = "Neutral"},

    [2447] = {amount = 96000, faction = "Horde"},
    [12209] = {amount = 10000, faction = "Horde"},
    [3576] = {amount = 22000, faction = "Horde"},
    [3530] = {amount = 250000, faction = "Horde"},
    [4625] = {amount = 19000, faction = "Horde"},
    [4234] = {amount = 60000, faction = "Horde"},
    [3860] = {amount = 18000, faction = "Horde"},
    [8544] = {amount = 250000, faction = "Horde"},
    [8170] = {amount = 60000, faction = "Horde"},
    [13935] = {amount = 10000, faction = "Horde"},

    [2318] = {amount = 180000, faction = "Alliance"},
    [1251] = {amount = 800000, faction = "Alliance"},
    [2319] = {amount = 110000, faction = "Alliance"},
    [3820] = {amount = 33000, faction = "Alliance"},
    [5095] = {amount = 14000, faction = "Alliance"},
    [3575] = {amount = 28000, faction = "Alliance"},
    [12210] = {amount = 20000, faction = "Alliance"},
    [6450] = {amount = 600000, faction = "Alliance"},
    [12359] = {amount = 24000, faction = "Alliance"},
    [8836] = {amount = 20000, faction = "Alliance"},


    [2770] = {craftable = 2840, makes = "Copper Bar"},
    [14047] = {craftable = 14529, makes = "Runecloth Bandage"},
    [1015] = {craftable = 12209, makes = "Lean Wolf Steak"},
    [2678] = {craftable = 12209, makes = "Lean Wolf Steak"},
    [2771] = {craftable = 3576, makes = "Tin Bar"},
    [2592] = {craftable = 3530, makes = "Wool Bandage"},
    [4338] = {craftable = 8544, makes = "Mageweave Bandage"},
    [13889] = {craftable = 13935, makes = "Baked Salmon"},
    [3713] = {craftable = 13935, makes = "Baked Salmon"},
    [2589] = {craftable = 1251, makes = "Linen Bandage"},
    [6361] = {craftable = 5095, makes = "Rainbow Fin Albacore"},
    [2772] = {craftable = 3575, makes = "Iron Bar"},
    [12184] = {craftable = 12210, makes = "Roast Raptor"},
    [2692] = {craftable = 12210, makes = "Roast Raptor"},
    [4306] = {craftable = 6450, makes = "Silk Bandage"},
    [10620] = {craftable = 12359, makes = "Thorium Bar"},
    [3858] = {craftable = 3860, makes = "Mithril Bar"},
    [4603] = {craftable = 6887, makes = "Spotted Yellowtail"}
}

local factionColours = {
    Neutral = "",
    Horde = "|cFFDD2222",
    Alliance = "|cFF4488FF"
}

local previousItemID
local tooltipLine

local function formatAmount(amount)
    local formatted = amount
    while true do  
      formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1k')
      if (k==0) then
        break
      end
    end
    return formatted
end

local function appendAQInfo(tooltip) 
    local itemName, itemLink = tooltip:GetItem() 
    if not itemName then return end

    local itemID = select(1, GetItemInfoInstant(itemName))
    
    if itemID == nil then
        itemID = tonumber(string.match(itemLink, "item:?(%d+):"))
        if itemID == nil then return end
    end

    if previousItemID == itemID then
        tooltip:AddLine(tooltipLine)
        return
    end
    
    local itemDetails = ITEMS[itemID]
    if not itemDetails then return end

    previousItemID = itemID

    if itemDetails.craftable then
        local craftedItem = ITEMS[itemDetails.craftable]
        tooltipLine = factionColours[craftedItem.faction] .. "AQ: For " .. itemDetails.makes .. " (" .. formatAmount(craftedItem.amount) .. ")"
    else
        tooltipLine = factionColours[itemDetails.faction] ..  "AQ: " .. formatAmount(itemDetails.amount)
    end

    tooltip:AddLine(tooltipLine)
end


local function init()
    GameTooltip:HookScript("OnTooltipSetItem", appendAQInfo)
end

init()
